#ifndef ShallowAngleFEIX_h
#define ShallowAngleFEIX_h

#include "MPXAlgo/MediPixAlgo.h"

// This algorithm is using an object put in the StoreGate
//  by BlobsFinder. I need to know the object.
#include "BlobsFinder/BlobsFinder.h"

#include <vector>

using namespace std;

#define __HEAD_INDX 0
#define __TAIL_INDX 1

class ShallowAngleFEIX : public MediPixAlgo {

public:

  ShallowAngleFEIX();
  virtual ~ShallowAngleFEIX() { };

  // You ought to implement Init(), Execute() and Finalize()
  //  when you inherit from MediPixAlgo.  This model gives you
  //  direct access to data and services.
  void Init();
  void Execute();
  void Finalize();

  vector<pair<Float_t, Float_t> > FindLimitPixels(blob);
  Int_t GuessNumberOfDeltaRaysFromUnbalance(Int_t &, Int_t &);

private:

  AllBlobsContainer * m_aB;
  Int_t m_minNPixels;
  Int_t m_guardDistanceX;
  Int_t m_guardDistanceY;
  Float_t m_pixSizeX;
  Float_t m_pixSizeY;
  Float_t m_dRayBalSearch;
  Int_t m_minXWidth;

  // for output
  vector<Float_t> m_distanceToCenter;
  Int_t m_clusterSize;
  vector<Float_t> m_mipLength;
  vector<Float_t> m_mipLength_X;
  Double_t m_totalMIPsLength;
  Int_t m_clusterHeight;

  vector<Int_t> m_totPerSegment; // Total TOT per segment/pixel
  vector<Float_t> m_chargeWeights; // Charge weight, normalized to the total TOT of the track

  ClassDef(ShallowAngleFEIX, 1)
};

#endif
